-- MASTER USER
DROP USER 'smartdata'@'localhost';
CREATE USER 'smartdata'@'localhost' IDENTIFIED BY '1ol31lSh010mG9wY';
GRANT SELECT, INSERT, UPDATE ON smartdata_v1.* TO 'smartdata'@'localhost';
GRANT EXECUTE ON FUNCTION smartdata_v1.counter TO 'smartdata'@'localhost';
GRANT SELECT, INSERT, UPDATE ON smartdata.* TO 'smartdata'@'localhost';
GRANT EXECUTE ON FUNCTION smartdata.counter TO 'smartdata'@'localhost';
FLUSH PRIVILEGES;

-- READ ONLY USER
DROP USER 'smartdata_readonly'@'localhost';
CREATE USER 'smartdata_readonly'@'localhost' IDENTIFIED BY '6n<HfOuY|5}6o(D';
GRANT SELECT ON smartdata_v1.* TO 'smartdata_readonly'@'localhost';
FLUSH PRIVILEGES;

./command.php create domain hydro
GRANT MODIFY ON hydro_v1_2_si TO hydro;
GRANT MODIFY ON hydro_v1_2_digital TO hydro;
GRANT MODIFY ON hydro_v1_1_si TO hydro;
GRANT MODIFY ON hydro_v1_1_digital TO hydro;
GRANT SELECT ON hydro_v1_2_si TO hydro;
GRANT SELECT ON hydro_v1_2_digital TO hydro;
GRANT SELECT ON hydro_v1_1_si TO hydro;
GRANT SELECT ON hydro_v1_1_digital TO hydro;
GRANT SELECT ON hydro_v1_2_si TO public;
GRANT SELECT ON hydro_v1_2_digital TO public;
GRANT SELECT ON hydro_v1_1_si TO public;
GRANT SELECT ON hydro_v1_1_digital TO public;

./command.php create domain smartlisha
./command.php create domain smartlisha_bc
GRANT SELECT ON smartlisha_v1_2_si TO public;
GRANT SELECT ON smartlisha_v1_2_digital TO public;
GRANT SELECT ON smartlisha_v1_1_si TO public;
GRANT SELECT ON smartlisha_v1_1_digital TO public;
GRANT SELECT ON smartlisha_bc_v1_2_si TO public;
GRANT SELECT ON smartlisha_bc_v1_1_digital TO public;
GRANT SELECT ON smartlisha_bc_v1_2_digital TO public;
GRANT SELECT ON smartlisha_bc_v1_1_si TO public;

./command.php create domain multicore
GRANT SELECT ON multicore_v1_1_si TO public;
GRANT SELECT ON multicore_v1_2_digital TO public;
GRANT SELECT ON multicore_v1_2_si TO public;
GRANT SELECT ON multicore_v1_1_digital TO public;

./command.php create domain public
GRANT MODIFY ON public_v1_2_si TO public;
GRANT MODIFY ON public_v1_2_digital TO public;
GRANT MODIFY ON public_v1_1_si TO public;
GRANT MODIFY ON public_v1_1_digital TO public;
GRANT SELECT ON public_v1_2_si TO public;
GRANT SELECT ON public_v1_2_digital TO public;
GRANT SELECT ON public_v1_1_si TO public;
GRANT SELECT ON public_v1_1_digital TO public;

./command.php create domain tutorial
GRANT MODIFY ON tutorial_v1_1_digital TO tutorial;
GRANT MODIFY ON tutorial_v1_2_si TO tutorial;
GRANT MODIFY ON tutorial_v1_2_digital TO tutorial;
GRANT MODIFY ON tutorial_v1_1_si TO tutorial;
GRANT SELECT ON tutorial_v1_1_digital TO tutorial;
GRANT SELECT ON tutorial_v1_2_si TO tutorial;
GRANT SELECT ON tutorial_v1_2_digital TO tutorial;
GRANT SELECT ON tutorial_v1_1_si TO tutorial;
GRANT SELECT ON tutorial_v1_1_digital TO public;
GRANT SELECT ON tutorial_v1_2_si TO public;
GRANT SELECT ON tutorial_v1_2_digital TO public;
GRANT SELECT ON tutorial_v1_1_si TO public;

./command.php create domain tutorial solar_farm
GRANT SELECT ON solar_farm_v1_1_digital TO public;
GRANT SELECT ON solar_farm_v1_2_si TO public;
GRANT SELECT ON solar_farm_v1_2_digital TO public;
GRANT SELECT ON solar_farm_v1_1_si TO public;


#./command.php create domain smartsolarbuilding
#./command.php create domain solar_farm
#./command.php create domain substation
#./command.php create domain underwater_rov

INSERT INTO `clients` VALUES
(DEFAULT, 'A7B64D415BD3E97B', 'Gateway LISHA'            , 'smartlisha'        , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E97C', 'Gateway SAPIENS'          , 'smartsolarbuilding', 'rw', 1),
(DEFAULT, 'A7B64D415BD3E97E', 'Gateway EBUS'             , 'ebus'              , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E97F', 'Teste WiFi Fraport'       , 'wifi'              , 'rw', 0),
(DEFAULT, 'A7B64D415BD3E97B', 'Gateway LISHA'            , 'smartlisha_bc'     , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E980', 'Teste EBus Caciano'       , 'ebus'              , 'rw', 0),
(DEFAULT, 'A7B64D415BD3E983', 'Huegel'                   , 'public'            , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E982', 'Hoffmann Dados Multicore' , 'multicore'         , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E986', 'Felipe Adachi'            , 'underwater_rov'    , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E987', 'Carlos Eduardo'           , 'public'            , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E988', 'Renato Souza (SO2)'       , 'public'            , 'rw', 1),
(DEFAULT, 'A7B64D415BD3E989', 'Makhles R. Lange (SO2)'   , 'public'            , 'rw', 1);


-- DOMAINS
--INSERT INTO `counters` VALUES ('public', 0);
--INSERT INTO `counters` VALUES ('smartlisha', 0);
--INSERT INTO `counters` VALUES ('smartsolarbuilding', 0);
--INSERT INTO `counters` VALUES ('seccom', 0);
--INSERT INTO `counters` VALUES ('smartpark', 0);
--INSERT INTO `counters` VALUES ('tractebel', 0);

-- GATEWAYS
--INSERT INTO `gateways` VALUES
--(default, 'A7B64D415BD3E97B', 'Gateway LISHA',      0, 'smartlisha',         'rw'),
--(default, 'A7B64D415BD3E97C', 'Gateway SAPIENS',    0, 'smartsolarbuilding', 'rw'),
--(default, 'A7B64D415BD3E97E', 'Gateway EBUS',       0, 'ebus',               'rw'),
--(default, 'A7B64D415BD3E97F', 'Teste WiFi Fraport', 0, 'wifi',               'rw');