# -*- coding: utf-8 -*-
#!/usr/bin/env python3


import numpy
import numpy.random as rand
from keras.models import model_from_json
from mapping import attributes,attributes2
import math
import sys
import json
import tornado.ioloop
import tornado.web
import tornado.locks
import ast
import subgroups
import collections
from collections import deque
from subgroups import TARGETS
from base64 import b64encode,b64decode
from struct import pack,unpack
import pickle
import time
import requests

attach_url ='https://iot.lisha.ufsc.br/api/attach.php'
create_url ='https://iot.lisha.ufsc.br/api/create.php'
put_url ='https://iot.lisha.ufsc.br/api/put.php'



MY_CERTIFICATE = ['testecert'+'.pem', 'testecert'+'.key']

#---------------------#---------------------#---------------------#---------------------#---------------------#

result = {
        'smartdata' :
            [
            
                {
                
                'version' : '1.1',
                'unit'    : 2224179492,
                'value'   : -1,
                'error'   : 0,
                'confidence' : 0,
                'x'       : 0,
                'y'       : 0,
                'z'       : 0,
                't'       : 0,
                'dev'   : 0
                
                }
            ]
        
        
    }
        
    

#---------------------#---------------------#---------------------#---------------------#---------------------#




window_size=2

global_cache = {'time':'value'}
norm_x = {}
norm_y = {}
models={}

threshold=0

residuals=[]

sliding_window = deque(window_size*[0],window_size)

#time_curr=1
#time_prev=0

def get_time():
    return time.time()

class timestamps(object):
    def __init__(self):
        self.cond = tornado.locks.Condition()
        self.time_curr=1
        self.time_prev=0
        
    def get_current(self):
        return self.time_curr
    def get_prev(self):
        return self.time_prev
    def update_time(self, timestamp):
        self.time_prev=self.time_curr
        self.time_curr=timestamp
        self.cond.notify_all()
        

global_timestamps = timestamps()


class MainHandler(tornado.web.RequestHandler):
    
    #Post
    #Recebe smartdata e, caso não seja o primeiro SD de determinado timestep, armazena o valor até que todos os SD's de determinado timesteps tenham sido enviados. Iniciando-se um novo timestep, recupera-se da cache montada os atributos regressores  para cada atributo alvo (mapeado em subgroups), carrega-se o modelo de rede neural de cada atributo alvo, realiza a predição e o resíduo associado. A média do quadrado dos resíduos é comparado com o valor threshold para se determinar a falha no timestep imediatamente passado, e o resultado é enviado à plataforma IoT.
    def post(self):
        global global_cache
        print("post!")
        try:
            param = self.get_body_argument("smartdata")
            js=json.dumps(param)
            print("param:",param)
            data={"smartdata": ast.literal_eval(param)}
            #print(nn)
            global_timestamps.update_time(data['smartdata']['timestamp'])
            #target = self.find_attribute( data )
            #print("current>",global_timestamps.get_current())
            #print("past>   ",global_timestamps.get_prev())
            time_curr=global_timestamps.get_current()
            time_prev=global_timestamps.get_prev()
            #print("time current:",time_curr)
            target = self.find_attribute( data )
            print("target>",target)
            #print("update>",self.update_cache(target,data['smartdata']['value'],nn))
            self.update_cache(target,data['smartdata']['value'],global_cache)
            #print("update>",self.get_cache(global_cache))
            if time_curr == time_prev or time_prev==1:
                self.update_cache(target,data['smartdata']['value'],global_cache)
		print("inside if!!!")
		print("time_curr>",time_curr)
		print("time_prev>",time_prev)
            
            else:
                self.clear_res()
                current_cache=self.get_cache(global_cache)
                
                self.appends(current_cache,sliding_window)
                
                past_cache=self.get_window(sliding_window,0)
                current_cache=self.get_window(sliding_window,1)
                
                print("past cache>>",past_cache)
                print("current cache>>",current_cache)
                
                
                global_cache = {'time': time_curr}
                
                
                self.update_cache(target,data['smartdata']['value'],global_cache)
                
                for attribute in TARGETS:
                    
                    regressors=self.get_regressors(attribute)
                    
                    input_set = self.make_input(regressors,attribute,current_cache,past_cache)
                    
                    value=current_cache[attribute]
                    
                    print("input set for target",attribute,">",input_set)
                    #voltar bloco baixo apos norm
                    nx,ny=self.get_norm_file(attribute)
                    print("nx",nx)
                    print("ny",ny)
                    input_normalized,value_normalized = self.normalize(nx,ny,input_set,value)
                    input_set=numpy.array(input_set)
                    #print("input_set>",input_set)
                    input_set=input_set.reshape(1,-1)
                    print("input_set>",input_set)
                    value=numpy.array(value)
                    #print("value>",value)
                    value=value.reshape(1,-1)
                    print("value>",value)
                    #value_normalized=value
                    #input_normalized=input_set
                    print("input normalized>",input_normalized)
                    print("value normalized",value_normalized)
                    
                    mod = self.get_model_file(attribute)
                    
                    print("model for",attribute,">",self.get_model_file(attribute))
                    
                    res=self.predict(input_normalized,value_normalized,mod)
                    res=res*res
                    self.insert_residual(attribute,res)
                    print("residual for",attribute,"is>",res)
		    #Linha abaixo é apenas para mandar o residuo de 1 atributo alvo - quando tiver mais de um, retirar
                    self.send_result(time_prev,1,res)
                    
                res_vector = self.get_residuals()
                print("list of residuals is>",res_vector)
                fault,qmean=self.evaluate_res(res_vector)
                print("Fault for ts ",time_prev,"is>",fault)
		#Linha abaixo comentada para enviar o residuo de apenas 1 atributo alvo - quando mais de um, voltar
                #self.send_result(time_prev,fault,qmean)
            
            regressors = self.get_regressors( target )
            
            #time_prev=time_curr
        except:
            js = "{\"error\":\"Parameter smartdata (json) missing\"}"
#---------------------#---------------------#---------------------#---------------------#---------------------#

    def find_attribute(self,smart_data):
        #print("unit:",smart_data['smartdata']['unit'])
        
        for attribute in attributes:
            if (int(smart_data['smartdata']['unit']),int(smart_data['smartdata']['x']),int(smart_data['smartdata']['y']),int(smart_data['smartdata']['z'])) == (int(attribute[1][1]),int(attribute[2][1]),int(attribute[3][1]),int(attribute[4][1])): 
                #print("found:",attribute[0])
                target=attribute[0]
        
        return target


#---------------------#---------------------#---------------------#---------------------#---------------------#

    def get_regressors(self,target):
            #print("get regressors argument>")
            regressors={}
            try:
                #print("regressors>",getattr(subgroups, target))
                regressors = getattr(subgroups, target)
            
            except AttributeError:
                #print("error aqui:")
                #regressors={}
                pass
            
            #print("regressors>",regressors)
            return regressors

#---------------------#---------------------#---------------------#---------------------#---------------------#

    def make_input(self, regressors, attribute, current, past):
        dataset = []
        for regressor in regressors:
            
            reg=attributes2[regressor[0]]
            if regressor[1]==1:
                val=past[regressor[0]]
                if int(reg['unit'])==65537:
                    val=b64decode(val)
                    val,=unpack('<d',val)
                    #print("val>",val)
                dataset.append(val)
            else:
                val=current[regressor[0]]
                if int(reg['unit'])==65537:
                    val=b64decode(val)
                    val,=unpack('<d',val)
                    #print("val>",val)
                dataset.append(val)
        return numpy.array(dataset)
                


#---------------------#---------------------#---------------------#---------------------#---------------------#

    def get_norm_file(self,target):
        print("into norm_file")
        val1 = norm_x.get(target)
        print("val1:",val1)
        if val1 is None:
            with open('scaler_'+target+'_x', 'rb') as f:
                val1=pickle.load(f)
                print("val1 apos load>",val1)
                norm_x[target] = val1
        val2 = norm_y.get(target)
        print("val2:",val2)
        if val2 is None:
            with open('scaler_'+target+'_y', 'rb') as f:
                val2=pickle.load(f)
                print("val2 apos load>",val2)
                norm_y[target] = val2
        
        
        return val1,val2


#---------------------#---------------------#---------------------#---------------------#---------------------#

    def get_model_file(self,target):
        targ=target+'_model.json'
        weights_file=target+'_model.h5'
   
        model = models.get(target)
        if model is None:
            with open(targ) as f:
                val=f.read()
                model = model_from_json(val)
                model.load_weights(weights_file)
                model.compile(loss='mean_squared_error', optimizer='adam', metrics=['mean_squared_error'])
                models[target]=model
        
        return model


#---------------------#---------------------#---------------------#---------------------#---------------------#


    def normalize(self,nx,ny,dataset,value):
        
        dataset=dataset.reshape(1, -1)
        
        data_normalized = nx.transform(dataset)
         
        value_normalized=ny.transform(value)
        
        #print("data_normalized",data_normalized)
        #print("value_normalized",value_normalized)
        
        return data_normalized,value_normalized

#---------------------#---------------------#---------------------#---------------------#---------------------#



    def predict(self, _input, value, model):
        py=model.predict(_input)
        #print("predicted target>",py)
        #print("real target>",value)
        
        residual= value-py
        
        return residual
    
        

#---------------------#---------------------#---------------------#---------------------#---------------------#

    def insert_residual(self,attribute,value):
        _tuple=(attribute,value)
        residuals.append(_tuple)
        
#---------------------#---------------------#---------------------#---------------------#---------------------#
    def get_residuals(self):
    
        return residuals

#---------------------#---------------------#---------------------#---------------------#---------------------#

    def evaluate_res(self,resid_vector):
        
        qmean=(sum(j*j for i, j in resid_vector))/len(resid_vector)
        
        if qmean>threshold:
            fault=1
        else:
            fault=0

        return fault,qmean
        
        

#---------------------#---------------------#---------------------#---------------------#---------------------#
    def send_result(self,time,fault,qmean):
        #print("into send!")
        smrt={}
        session = requests.Session()
        session.headers = {'Content-type' : 'application/json'}
        session.cert = MY_CERTIFICATE
        
        #print("fault pre>",fault)
        
        res=result['smartdata']
        res[0].update({'value':float(qmean)})
        
        res[0].update({'t':int(time)})
        
        #res.update({'error':float(qmean)})
        #print("res>",res)
        
        
        #res.update({'confidence':now})
        
        smrt['smartdata']=res
        
        msg=json.dumps(smrt)
        
        
        print("smartdata to send>",msg)
        response = session.post(put_url, msg)
        print("Put[", str(response.status_code), "] (", len(msg),")",msg)
        now=get_time()
        now=int(now*1000000)
        #print("total time>",(now-time)/1000000)
        print("ts smartadata>",time,"now>",now)

#---------------------#---------------------#---------------------#---------------------#---------------------#
    def clear_res(self):
        residuals.clear()
    
#---------------------#---------------------#---------------------#---------------------#---------------------#

    def update_cache(self, target,value, net):
        net.update({target:value})
#---------------------#---------------------#---------------------#---------------------#---------------------#
        
    def get_cache(self,net):
        return net
#---------------------#---------------------#---------------------#---------------------#---------------------#
    
    def assign_cache(self,source,recipient):
        for key in source:
            recipient.update({key:source[key]})
        return recipient
#---------------------#---------------------#---------------------#---------------------#---------------------#
    
    def appends(self,cache,window):
        #print("window pre",window,"\n")
        window.append(cache)
        #print("window pos",window,"\n")
#---------------------#---------------------#---------------------#---------------------#---------------------#
        
    def get_window(self,window,timestep):
        return window[timestep]
#---------------------#---------------------#---------------------#---------------------#---------------------#
    
    def get_all_window(self,window):
        return window
    
#---------------------#---------------------#---------------------#---------------------#---------------------#
    
def make_app():
    return tornado.web.Application([
        (r"/confidence", MainHandler),
    ])
#---------------------#---------------------#---------------------#---------------------#---------------------#


def load_global_cache():
    global_cache = {'time':0}
    return global_cache
#---------------------#---------------------#---------------------#---------------------#---------------------#


def load_queue():
    sliding_window = deque(window_size*[0],window_size)
    return sliding_window
#---------------------#---------------------#---------------------#---------------------#---------------------#




if __name__ == "__main__":
    print("init main")
    global_cache = load_global_cache()
    sliding_window=load_queue()
    
    app = make_app()
    app.listen(8989)
    print("Server ready and accepting connection on port 8989...")
    tornado.ioloop.IOLoop.current().start()

